#!/usr/bin/perl -w
use lib "/srv/www/vhosts/cacti/scripts";
use mod_query_nmon;
use Storable;

if(!defined($ARGV[0]) or !defined($ARGV[1])) {
	print "for displaying all available information: query_nmon.pl <servername or IP> DUMPINFO\n\n";
	print "Usage for simple types: query_nmon.pl <servername or IP> <category>\n";
	print "Usage for complex types: query_nmon.pl <servername or IP> <category> get <attribute1> <attribute2>\n";
	print "Usage for complex types: query_nmon.pl <servername or IP> <category> query <attribute1>\n";
	print "Usage for complex types: query_nmon.pl <servername or IP> <category> <index|num_indexes>\n";
	exit 0;
}


my $servername = $ARGV[0];

my $cachedir = "/var/cache/cacti/";
my $cachefile = $cachedir . $servername . ".cache";
my $debug = 0;
my $nmondir = "/usr/net/bin/nmon/";
my $ssh_idfile = "/home/cacti/.ssh/id_rsa";
my $nmon_runmode = "daemon";

die("unable to update NMON cache") if(check_and_update_cache($cachefile,$servername,$nmondir,$ssh_idfile,$debug,$nmon_runmode) == 2);
die("host ist down") if(check_and_update_cache($cachefile,$servername,$nmondir,$ssh_idfile,$debug,$nmon_runmode) == 3);

my $hashref = retrieve($cachefile);

&query(@ARGV);

sub query {
	my $servername = shift;
	my $category = shift;
	my $command = shift;
	my $attribute1 = shift;;
	my $attribute2 = shift;



	if(defined($category) and $category eq "DUMPINFO") {
		use Data::Dumper;
		print Dumper($hashref);	
	}
	elsif(defined($category)) {
		#commands with subcommand and attribute
		if(defined($command) and defined($attribute1) and defined($attribute2)) {
			if($command eq 'get') {
				if(length($attribute1) > 0 and length($attribute2) > 0) {
					$value = $hashref->{COMPLEX}->{$category}->{$attribute2}->{$attribute1};
					print "$value\n";
				}
			}
		}
		#commands with subcommand
		elsif(defined($command) and defined($attribute1)) {
			if($command eq 'query') {
				if(length($attribute1) > 0) {
					foreach $key (sort { $a <=> $b } keys %{$hashref->{COMPLEX}->{$category}}) {
						$value = $hashref->{COMPLEX}->{$category}->{$key}->{$attribute1};
						print "$key:$value\n";
					}
				}
				else {
					print "Syntax Error\n";
				} 
			}
		}
		#commands with no subcommand
		elsif(defined($command)) {
			if($command eq 'index' or $command eq 'num_indexes') {
				if($command eq 'index') {
					foreach $key (sort { $a <=> $b } keys %{$hashref->{COMPLEX}->{$category}}) {
						print "$key\n";
					}
				}
				elsif($command eq 'num_indexes') {
					my $numkeys = keys %{$hashref->{COMPLEX}->{$category}};
					print "$numkeys\n";
				}
			}
		}
		#no command, must be a simple type
		elsif(!defined($command)) {
			foreach $key (sort keys %{$hashref->{SIMPLE}->{$category}}) {
				$value = $hashref->{SIMPLE}->{$category}->{$key};
				print "$key:$value ";
			}
			print "\n";
		}
	}
}
	
sub HELP_MESSAGE {
	print "HEEEEELP!\n";
}
